/* eslint-disable
 func-names,
 func-style,
 max-nested-callbacks,
 no-undefined,
 prefer-arrow-callback,
 */
/* global describe, it */

'use strict';

const appModulePath = require('app-module-path');
const assert = require('assert');

appModulePath.addPath('./');

const WebRequestUtils = require('lib/webRequestUtils');

describe('WebRequestUtils', function () {
    describe('WebRequestUtils::returnRequestAsResponse', function () {
        it('should return the arguments as an object', function () {
            const options = { baz: 42, foo: 'bar' };

            return WebRequestUtils.returnRequestAsResponse('/myEndpoint', options)
                .then(response => {
                    assert.deepStrictEqual('/myEndpoint', response.path);
                    assert.deepStrictEqual(options, response.options);
                });
        });
    });

    describe('WebRequestUtils::returnRequestAsResponseBody', function () {
        it('should return the arguments as a stringifed object under the property "body"', function () {
            const options = { baz: 42, foo: 'bar' };

            return WebRequestUtils.returnRequestAsResponseBody('/myEndpoint', options)
                .then(response => {
                    const responseBody = JSON.parse(response.body);

                    assert.deepStrictEqual('/myEndpoint', responseBody.path);
                    assert.deepStrictEqual(options, responseBody.options);
                });
        });
    });

    describe('WebRequestUtils::returnSomething', function () {
        it('should return the argument', function () {
            return WebRequestUtils.returnSomething('this')('that')
                .then(response => {
                    assert.deepStrictEqual('this', response);
                });
        });
    });
});
